//+------------+-----------------------------------------------------+
//| v.12.04.07 |                                            SSRC.mq4 |
//+------------+              Spearman,                              |
//|            |              Rosh                                   |
//|            |                                   |
//|            |              Bookkeeper, 2007, yuzefovich@gmail.com |
//+------------+-----------------------------------------------------+
// http://www.improvedoutcomes.com/docs/WebSiteDocs/Clustering/
// Clustering_Parameters/Spearman_Rank_Correlation_Distance_Metric.htm
// http://www.infamed.com/stat/s05.html
// http://www.metaquotes.net
// http://codebase.mql4.com/ru/1023
#property copyright ""
#property link      ""
//----
#property indicator_separate_window
#property indicator_maximum 1.3
#property indicator_minimum -1.3
#property indicator_level1 0.9
#property indicator_level2 -0.9
#property indicator_level3 0.75
#property indicator_level4 -0.75
#property indicator_level5 0
#property indicator_buffers 7
#property indicator_color1 Lime
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 clrDarkOrange
#property indicator_color7 clrWhite
//---- input parameters
//---- Snake 
extern int TotalBars=700;
extern int    SnakeRange   =14; 
extern int    FilterPeriod =21; 
extern double MartFiltr    =2;
extern int    PriceConst   =6; // 0 - Close
                               // 1 - Open
                               // 2 - High
                               // 3 - Low
                               // 4 - (H+L)/2
                               // 5 - (H+L+C)/3
                               // 6 - (H+L+2*C)/4
                               
                               
                               





 



                           
                               

extern string ____________Level_Up_; 
                        
extern double SRCUp=0.93 ;                           
extern double RsiUp=-0.94;
extern bool SoundAlto=false;
extern bool BullOnAlto=false;
extern string FileSoundBullAlto = "news.wav";
extern string ____________Level_Dn_;  
 
extern double SRCDn=-0.93 ;                           
extern double RsiDn=0.90;
extern bool BearOnAlto=false;
extern bool SoundBasso=false;
extern string FileSoundBearAlto = "alert2.wav"; 
bool EmailAlert=false;
bool RsiNormal=false; 
extern string ____________Set_Rsi_;
extern int     RsiPeriod=2;
extern int     RsiPrice=0;
extern int     RsiTf=0;
extern string ____________Set_CCI_;
extern bool    CCiOn=false;
extern bool    Ema50_On=true;
extern int     CCiPeriod=3;
extern int     CCiPrice=0; 
extern int     VPeriod=15; 
extern bool LineRsi=false; 
extern bool HistoSRC=false;
 
extern int     y=100;                    
//---- buffers
double SRCBuffer[];
double Axis[];
double Mart[];
double SignalUp[];
double RSI[];
double SignalDn[];
double Ema50[];
//---- SpearmanRankCorrelation
int    rangeN = 14; //   = 30 maximum
double R2[];
double multiply;
int    PriceInt[];
int    SortInt[];
int PlayedSoundH = False;
int PlayedSoundL = False;


//+------------------------------------------------------------------+
void MartAxis(int Pos) 
{ 
   int SnakeWeight,i,w,ww,Shift;
   double SnakeSum;
/*
   switch(PriceConst) 
   {
      case  0:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_CLOSE,Pos);    break;
      case  1:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_OPEN,Pos);     break;
      case  2:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_HIGH,Pos);     break;
      case  3:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_LOW,Pos);      break;
      case  4:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_MEDIAN,Pos);   break;
      case  5:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_TYPICAL,Pos);  break;
      case  6:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_WEIGHTED,Pos); break;
      default:  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_WEIGHTED,Pos); 
   }
*/
   Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PriceConst,Pos);

   for(Shift=Pos+SnakeRange+2;Shift>Pos;Shift--) 
   { 
      SnakeSum=0.0;
      SnakeWeight=0; 

      i=0; 
      w=Shift+SnakeRange; 
      while(w>=Shift) 
      { 
         i++; 
         SnakeSum+=i*SnakePrice(w); 
         SnakeWeight+=i; 
         w--; 
      }

      ww=Shift-SnakeRange;
      if(ww<Pos) ww=Pos;
      while(w>=ww) 
      { 
         i--; 
         SnakeSum+=i*SnakePrice(w);
         SnakeWeight+=i; 
         w--; 
      }
      Axis[Shift]=SnakeSum/SnakeWeight; 
   } 
   return; 
}

//----
double SnakePrice(int Shift) 
{
   switch(PriceConst) 
   {
      case  0: return(Close[Shift]);
      case  1: return(Open[Shift]);
      case  2: return(High[Shift]);
      case  3: return(Low[Shift]);
      case  4: return((High[Shift]+Low[Shift])/2);
      case  5: return((Close[Shift]+High[Shift]+Low[Shift])/3);
      case  6: return((2*Close[Shift]+High[Shift]+Low[Shift])/4);
      default: return(Close[Shift]); 
   } 
}

//+------------------------------------------------------------------+
void SmoothOverMart(int Shift) 
{ 
   double t,b;
   t=Axis[ArrayMaximum(Axis,FilterPeriod,Shift)];
   b=Axis[ArrayMinimum(Axis,FilterPeriod,Shift)];
   Mart[Shift]=(2*(2+MartFiltr)*Axis[Shift]-(t+b))/2/(1+MartFiltr);
   return; 
}

//+------------------------------------------------------------------+
double SpearmanRankCorrelation(double &Ranks[], int N) 
{ 
   double res,z2;
   for(int i=0;i<N;i++) 
   { 
      z2 += MathPow(Ranks[i] - i - 1, 2); 
   }
   res=1-6*z2/(MathPow(N,3)-N); 
   return(res); 
}

//+------------------------------------------------------------------+
void RankPrices(int &InitialArray[]) 
{ 
   double dcounter, averageRank;
   int i, k, m, dublicat, counter, etalon; 
   double TrueRanks[];

   ArrayResize(TrueRanks, rangeN); 
   ArrayCopy(SortInt, InitialArray);
   for(i=0;i<rangeN;i++) TrueRanks[i]=i+1; 

   ArraySort(SortInt, 0, 0, MODE_DESCEND);
   for(i=0;i<rangeN-1;i++) 
   { 
      if(SortInt[i]!=SortInt[i+1]) continue;
      dublicat=SortInt[i]; 
      k=i+1; 
      counter=1; 
      averageRank=i+1;
      while(k<rangeN) 
      { 
         if(SortInt[k]==dublicat) 
         {
            counter++; 
            averageRank+=k+1; 
            k++; 
         } else break; 
      }
      dcounter=counter; 
      averageRank=averageRank/dcounter;
      for(m=i;m<k;m++) TrueRanks[m]=averageRank; i=k; 
   }
   for(i=0;i<rangeN;i++) 
   { 
      etalon=InitialArray[i]; 
      k=0;
      while(k<rangeN) 
      { 
         if(etalon==SortInt[k]) 
         { 
            R2[i]=TrueRanks[k]; 
            break; 
            
            
             
         } 
         k++; 
      } 
   } 
   return; 
}

//+------------------------------------------------------------------+
int init() 
{
   IndicatorBuffers(6);
   
   SetIndexBuffer(0,SRCBuffer); 
   SetIndexStyle(0,DRAW_LINE);
    if(HistoSRC)
   SetIndexStyle(0,DRAW_HISTOGRAM);
   
   SetIndexBuffer(1,Axis); 
   SetIndexStyle(1,DRAW_NONE);
   
   SetIndexBuffer(2,Mart); 
   SetIndexStyle(2,DRAW_NONE);
   
    SetIndexBuffer(3,SignalUp); 
    SetIndexStyle(3,DRAW_ARROW,0,2);
    SetIndexArrow(3, 233);
    
   SetIndexBuffer(4,RSI); 
   SetIndexStyle(4,DRAW_HISTOGRAM);
   if(LineRsi)
   SetIndexStyle(4,DRAW_LINE);
   
   
    SetIndexBuffer(5,SignalDn); 
    SetIndexStyle(5,DRAW_ARROW,0,2);
    SetIndexArrow(5, 234);
    
     SetIndexBuffer(6,Ema50); 
   SetIndexStyle(6,DRAW_LINE);
   
   ArrayResize(R2,rangeN);
   ArrayResize(PriceInt,rangeN);
   ArrayResize(SortInt,rangeN);

   if(rangeN>30) 
      IndicatorShortName("Decrease rangeN input!");
   else 
      IndicatorShortName("SSRC( SR:"+SnakeRange+", FP:"+FilterPeriod+" )");
   multiply=MathPow(10,Digits); 
   return(0); 
}

//+------------------------------------------------------------------+
int deinit() 
{ 
   return(0); 
}

//+------------------------------------------------------------------+
int start() 
{ 
   int i,k,limit,limit2,limit3;
   int counted_bars=TotalBars; 
   if(rangeN>30) return(-1);
   if(counted_bars==0) {
      limit=TotalBars-(rangeN+FilterPeriod+SnakeRange+4);
      limit2=TotalBars-(SnakeRange+2);
      limit3=TotalBars-(FilterPeriod+SnakeRange+3); 
   }
   if(counted_bars>0) { 
      limit=TotalBars+1; //-counted_bars
      limit2=limit; 
      limit3=limit; 
   }
   for(i=limit2;i>=0;i--) MartAxis(i);
   for(i=limit3;i>=0;i--) SmoothOverMart(i);
   for(i=limit;i>=0;i--) 
   { 
      for(k=0;k<rangeN;k++) PriceInt[k]=Mart[i+k]*multiply;
      RankPrices(PriceInt); 
      SRCBuffer[i]=SpearmanRankCorrelation(R2,rangeN);
      if(SRCBuffer[i]>1.0) SRCBuffer[i]=1.0; 
      if(SRCBuffer[i]<-1.0) SRCBuffer[i]=-1.0; 
       
       RSI[i]=iRSI(NULL,RsiTf,RsiPeriod,RsiPrice,i)*2/100-100/100; 
       if(CCiOn)
       RSI[i]=iCCI(NULL,RsiTf,CCiPeriod,CCiPrice,i)/100; 
       if(Ema50_On)
       Ema50[i]=Close[i]/Point/60 - iMA(NULL, 0,50 , 0, 3, PRICE_CLOSE, i)/Point/60;
       
      // if(RsiNormal)
       //  RSI[i]=iRSI(NULL,0,2,0,i)/100;
       
      if( SRCBuffer[i]>SRCUp&&RSI[i]<RsiUp
      //&&RSI[i+1]<RsiUp
      // && SRCBuffer[i]>SRCBuffer[i+1]
      )
     
      SignalUp[i]=iRSI(NULL,RsiTf,RsiPeriod,RsiPrice,i)*2/100-100/100; 
      
      
      
      
      
      if( SRCBuffer[i]<SRCDn&&RSI[i]>RsiDn
      //&&RSI[i+1]<RsiUp
    //  && SRCBuffer[i]>SRCBuffer[i+1]
      )
     
      SignalDn[i]=iRSI(NULL,RsiTf,RsiPeriod,RsiPrice,i)*2/100-100/100;  
      
      
      
    
   } 
   
       if(  RSI[0]>RsiUp ){PlayedSoundH = False;}
   
       if(  RSI[0]<RsiDn  ){PlayedSoundL = False;} 
    
   
     if( RSI[0]<RsiUp&& SRCBuffer[0]>SRCUp
      //&&RSI[i+1]<RsiUp
    // && SRCBuffer[0]>SRCBuffer[1]
      && PlayedSoundH == False){
     if(BullOnAlto)Alert(Symbol(), " (", Period(), " min)SSRC3-Alto ",SRCBuffer[0] ," SSRC ",  RSI[0] ,"  Rsi  "  ,Ema50[0] ,"  Ema50  ",  "  PipsLow "); 
     if(EmailAlert) SendMail(StringConcatenate("Alert from indicator \"","\""),StringConcatenate("BullAlto ",Symbol()," at ",TimeToStr(TimeCurrent()),BullOnAlto));
     if (SoundAlto) PlaySound(FileSoundBullAlto);
     PlayedSoundH = True;}
    
    if( RSI[0]>RsiDn&& SRCBuffer[0]<SRCDn
      //&&RSI[i+1]<RsiUp
     // && SRCBuffer[i]>SRCBuffer[i+1] 
     && PlayedSoundL == False){
     if(BearOnAlto)Alert(Symbol(), " (", Period(), " min)SSRC3-Basso ",SRCBuffer[0] ," SSRC   ",  RSI[0] ," Rsi " , Ema50[0] , "  Ema50 ",  "Ema2-"); 
      if(EmailAlert) SendMail(StringConcatenate("Alert from indicator \"","\""),StringConcatenate("BearAlto ",Symbol()," at ",TimeToStr(TimeCurrent()),BearOnAlto));
     
    if (SoundBasso) PlaySound(FileSoundBearAlto);
    PlayedSoundL = True;}  
    
    
    
      ObjectCreate("SSRCs", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SSRCs","  SSRC:  "     +DoubleToStr(SRCBuffer[0] ,3),15, "Verdana", Gray);
      ObjectSet("SSRCs", OBJPROP_CORNER, 1);
      ObjectSet("SSRCs", OBJPROP_XDISTANCE, 20);
      ObjectSet("SSRCs", OBJPROP_YDISTANCE, 200+y); 
  
    if( SRCBuffer[0]>SRCUp)
      ObjectSetText("AFirma"," SSRC:  "     +DoubleToStr(SRCBuffer[0],3),15, "Verdana", Lime);
   if( SRCBuffer[0]<SRCDn )
      ObjectSetText("AFirma"," SSRC:  "     +DoubleToStr(SRCBuffer[0] ,3),15, "Verdana",Red); 
       
       
      ObjectCreate("SSRCr", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SSRCr","   Rsi:  "     +DoubleToStr(RSI[0],3),15, "Verdana", Gray);
      ObjectSet("SSRCr", OBJPROP_CORNER, 1);
      ObjectSet("SSRCr", OBJPROP_XDISTANCE, 20);
      ObjectSet("SSRCr", OBJPROP_YDISTANCE, 220+y); 
   
   
   if(RSI[0]>RsiDn )
      ObjectSetText("SSRCr","   Rsi:  "     +DoubleToStr(RSI[0],3),15, "Verdana", Lime);
   if(RSI[0]<RsiUp)
      ObjectSetText("SSRCr","   Rsi:  "     +DoubleToStr(RSI[0] ,3),15, "Verdana",Red); 
      
      
      double value =(MarketInfo(NULL,MODE_BID) - iClose(NULL,VPeriod,1))*100/iClose(NULL,VPeriod,1); 
      
      
     ObjectCreate("SSRCrV", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SSRCrV","   Trend:  "     +DoubleToStr(value,4),15, "Verdana", Gray);
      ObjectSet("SSRCrV", OBJPROP_CORNER, 1);
      ObjectSet("SSRCrV", OBJPROP_XDISTANCE, 20);
      ObjectSet("SSRCrV", OBJPROP_YDISTANCE, 240+y); 
   
   
   if(value>0 )
      ObjectSetText("SSRCrV","   Up:  "     +DoubleToStr(value,4),15, "Verdana", Lime);
   if(value<0)
      ObjectSetText("SSRCrV","   Dn:  "     +DoubleToStr(value ,4),15, "Verdana",Red); 
       
      
      
     ObjectCreate("SSRCrVp", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SSRCrVp","   Period: "     +DoubleToStr(VPeriod,0),15, "Verdana", Gray);
      ObjectSet("SSRCrVp", OBJPROP_CORNER, 1);
      ObjectSet("SSRCrVp", OBJPROP_XDISTANCE, 20);
      ObjectSet("SSRCrVp", OBJPROP_YDISTANCE, 260+y);  
         
      
   
   return(0); 
}

//+------------------------------------------------------------------+

